---
title: Create a change request
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Change Management
---

# Create a change request{% #create-a-change-request %}

{% tab title="v2" %}
**Note**: This endpoint is in preview and is subject to change. If you have any feedback, contact [Datadog support](https://docs.datadoghq.com/help/).
| Datadog site      | API endpoint                                                               |
| ----------------- | -------------------------------------------------------------------------- |
| ap1.datadoghq.com | POST https://api.ap1.datadoghq.com/api/v2/change-management/change-request |
| ap2.datadoghq.com | POST https://api.ap2.datadoghq.com/api/v2/change-management/change-request |
| app.datadoghq.eu  | POST https://api.datadoghq.eu/api/v2/change-management/change-request      |
| app.ddog-gov.com  | POST https://api.ddog-gov.com/api/v2/change-management/change-request      |
| us2.ddog-gov.com  | POST https://api.us2.ddog-gov.com/api/v2/change-management/change-request  |
| app.datadoghq.com | POST https://api.datadoghq.com/api/v2/change-management/change-request     |
| us3.datadoghq.com | POST https://api.us3.datadoghq.com/api/v2/change-management/change-request |
| us5.datadoghq.com | POST https://api.us5.datadoghq.com/api/v2/change-management/change-request |

### Overview

Create a new change request.

OAuth apps require the `cases_write` authorization [scope](https://docs.datadoghq.com/api/latest/scopes.md#change-management) to access this endpoint.



### Request

#### Body Data (required)

Change request payload.

{% tab title="Model" %}

| Parent field | Field                                   | Type      | Description                                                                            |
| ------------ | --------------------------------------- | --------- | -------------------------------------------------------------------------------------- |
|              | data [*required*]                  | object    | Data object to create a change request.                                                |
| data         | attributes [*required*]            | object    | Attributes for creating a change request.                                              |
| attributes   | change_request_linked_incident_uuid     | string    | The UUID of an incident to link to the change request.                                 |
| attributes   | change_request_maintenance_window_query | string    | The maintenance window query for the change request.                                   |
| attributes   | change_request_plan                     | string    | The plan associated with the change request.                                           |
| attributes   | change_request_risk                     | enum      | The risk level of the change request. Allowed enum values: `UNDEFINED,LOW,MEDIUM,HIGH` |
| attributes   | change_request_type                     | enum      | The type of the change request. Allowed enum values: `NORMAL,STANDARD,EMERGENCY`       |
| attributes   | description                             | string    | The description of the change request.                                                 |
| attributes   | end_date                                | date-time | The planned end date of the change request.                                            |
| attributes   | project_id                              | string    | The project UUID to associate with the change request.                                 |
| attributes   | requested_teams                         | [string]  | A list of team handles to request decisions from.                                      |
| attributes   | start_date                              | date-time | The planned start date of the change request.                                          |
| attributes   | title [*required*]                 | string    | The title of the change request.                                                       |
| data         | type [*required*]                  | enum      | Change request resource type. Allowed enum values: `change_request`                    |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "change_request_linked_incident_uuid": "00000000-0000-0000-0000-000000000000",
      "change_request_maintenance_window_query": "",
      "change_request_plan": "1. Deploy to staging 2. Run tests 3. Deploy to production",
      "change_request_risk": "LOW",
      "change_request_type": "NORMAL",
      "description": "Deploying new payment service v2.1",
      "end_date": "2024-01-02T15:00:00Z",
      "project_id": "d4bbe1af-f36e-42f1-87c1-493ca35c320e",
      "requested_teams": [
        "team-handle-1"
      ],
      "start_date": "2024-01-01T03:00:00Z",
      "title": "Deploy new payment service"
    },
    "type": "change_request"
  }
}
```

{% /tab %}

### Response

{% tab title="201" %}
Created
{% tab title="Model" %}
Response object for a change request.

| Parent field             | Field                                                     | Type            | Description                                                                                 |
| ------------------------ | --------------------------------------------------------- | --------------- | ------------------------------------------------------------------------------------------- |
|                          | data [*required*]                                    | object          | Data object for a change request response.                                                  |
| data                     | attributes [*required*]                              | object          | Attributes of a change request response.                                                    |
| attributes               | archived_at                                               | date-time       | Timestamp of when the change request was archived.                                          |
| attributes               | attributes [*required*]                              | object          | Custom attributes of the change request as key-value pairs.                                 |
| additionalProperties     | <any-key>                                                 | [string]        |
| attributes               | change_request_linked_incident_uuid [*required*]     | string          | The UUID of the linked incident.                                                            |
| attributes               | change_request_maintenance_window_query [*required*] | string          | The maintenance window query for the change request.                                        |
| attributes               | change_request_plan [*required*]                     | string          | The plan associated with the change request.                                                |
| attributes               | change_request_risk [*required*]                     | enum            | The risk level of the change request. Allowed enum values: `UNDEFINED,LOW,MEDIUM,HIGH`      |
| attributes               | change_request_type [*required*]                     | enum            | The type of the change request. Allowed enum values: `NORMAL,STANDARD,EMERGENCY`            |
| attributes               | closed_at                                                 | date-time       | Timestamp of when the change request was closed.                                            |
| attributes               | created_at [*required*]                              | date-time       | Timestamp of when the change request was created.                                           |
| attributes               | creation_source [*required*]                         | string          | The source from which the change request was created.                                       |
| attributes               | description [*required*]                             | string          | The description of the change request.                                                      |
| attributes               | end_date                                                  | date-time       | The planned end date of the change request.                                                 |
| attributes               | key [*required*]                                     | string          | The human-readable key of the change request.                                               |
| attributes               | modified_at [*required*]                             | date-time       | Timestamp of when the change request was last modified.                                     |
| attributes               | plan_notebook_id [*required*]                        | int64           | The notebook ID associated with the change request plan.                                    |
| attributes               | priority [*required*]                                | string          | The priority of the change request.                                                         |
| attributes               | project_id [*required*]                              | string          | The project UUID associated with the change request.                                        |
| attributes               | start_date                                                | date-time       | The planned start date of the change request.                                               |
| attributes               | status [*required*]                                  | string          | The current status of the change request.                                                   |
| attributes               | title [*required*]                                   | string          | The title of the change request.                                                            |
| attributes               | type [*required*]                                    | string          | The case type.                                                                              |
| data                     | id [*required*]                                      | string          | The identifier of the change request.                                                       |
| data                     | relationships                                             | object          | Relationships of a change request.                                                          |
| relationships            | change_request_decisions [*required*]                | object          | Relationship to change request decisions.                                                   |
| change_request_decisions | data [*required*]                                    | [object]        | Array of decision relationship data.                                                        |
| data                     | id [*required*]                                      | string          | The decision UUID.                                                                          |
| data                     | type [*required*]                                    | enum            | Change request decision resource type. Allowed enum values: `change_request_decision`       |
| relationships            | created_by [*required*]                              | object          | Relationship to a user.                                                                     |
| created_by               | data [*required*]                                    | object          | User relationship data.                                                                     |
| data                     | id [*required*]                                      | string          | The user UUID.                                                                              |
| data                     | type [*required*]                                    | string          | The user resource type.                                                                     |
| relationships            | modified_by [*required*]                             | object          | Relationship to a user.                                                                     |
| modified_by              | data [*required*]                                    | object          | User relationship data.                                                                     |
| data                     | id [*required*]                                      | string          | The user UUID.                                                                              |
| data                     | type [*required*]                                    | string          | The user resource type.                                                                     |
| data                     | type [*required*]                                    | enum            | Change request resource type. Allowed enum values: `change_request`                         |
|                          | included                                                  | [ <oneOf>] | Included resources related to the change request.                                           |
| included                 | Option 1                                                  | object          | An included user resource.                                                                  |
| Option 1                 | attributes [*required*]                              | object          | Attributes of an included user.                                                             |
| attributes               | email [*required*]                                   | string          | The email of the user.                                                                      |
| attributes               | handle [*required*]                                  | string          | The handle of the user.                                                                     |
| attributes               | name [*required*]                                    | string          | The name of the user.                                                                       |
| Option 1                 | id [*required*]                                      | string          | The user UUID.                                                                              |
| Option 1                 | type [*required*]                                    | string          | The resource type.                                                                          |
| included                 | Option 2                                                  | object          | An included change request decision resource.                                               |
| Option 2                 | attributes [*required*]                              | object          | Attributes of a change request decision in a response.                                      |
| attributes               | change_request_status [*required*]                   | enum            | The status of a change request decision. Allowed enum values: `REQUESTED,APPROVED,DECLINED` |
| attributes               | decided_at [*required*]                              | date-time       | Timestamp of when the decision was made.                                                    |
| attributes               | decision_reason [*required*]                         | string          | The reason for the decision.                                                                |
| attributes               | deleted_at [*required*]                              | date-time       | Timestamp of when the decision was deleted.                                                 |
| attributes               | request_reason [*required*]                          | string          | The reason for requesting the decision.                                                     |
| attributes               | requested_at [*required*]                            | date-time       | Timestamp of when the decision was requested.                                               |
| Option 2                 | id [*required*]                                      | string          | The decision UUID.                                                                          |
| Option 2                 | relationships                                             | object          | Relationships of a change request decision.                                                 |
| relationships            | modified_by [*required*]                             | object          | Relationship to a user.                                                                     |
| modified_by              | data [*required*]                                    | object          | User relationship data.                                                                     |
| data                     | id [*required*]                                      | string          | The user UUID.                                                                              |
| data                     | type [*required*]                                    | string          | The user resource type.                                                                     |
| relationships            | requested_by_user [*required*]                       | object          | Relationship to a user.                                                                     |
| requested_by_user        | data [*required*]                                    | object          | User relationship data.                                                                     |
| data                     | id [*required*]                                      | string          | The user UUID.                                                                              |
| data                     | type [*required*]                                    | string          | The user resource type.                                                                     |
| relationships            | requested_user [*required*]                          | object          | Relationship to a user.                                                                     |
| requested_user           | data [*required*]                                    | object          | User relationship data.                                                                     |
| data                     | id [*required*]                                      | string          | The user UUID.                                                                              |
| data                     | type [*required*]                                    | string          | The user resource type.                                                                     |
| Option 2                 | type [*required*]                                    | enum            | Change request decision resource type. Allowed enum values: `change_request_decision`       |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "archived_at": "2019-09-19T10:00:00.000Z",
      "attributes": {
        "<any-key>": []
      },
      "change_request_linked_incident_uuid": "",
      "change_request_maintenance_window_query": "",
      "change_request_plan": "",
      "change_request_risk": "LOW",
      "change_request_type": "NORMAL",
      "closed_at": "2019-09-19T10:00:00.000Z",
      "created_at": "2024-01-01T00:00:00Z",
      "creation_source": "CS_MANUAL",
      "description": "Deploying new payment service v2.1",
      "end_date": "2024-01-02T15:00:00Z",
      "key": "CHM-1234",
      "modified_at": "2024-01-01T00:00:00Z",
      "plan_notebook_id": 0,
      "priority": "NOT_DEFINED",
      "project_id": "d4bbe1af-f36e-42f1-87c1-493ca35c320e",
      "start_date": "2024-01-01T03:00:00Z",
      "status": "OPEN",
      "title": "Deploy new payment service",
      "type": "CHANGE_REQUEST"
    },
    "id": "CHM-1234",
    "relationships": {
      "change_request_decisions": {
        "data": [
          {
            "id": "decision-id-0",
            "type": "change_request_decision"
          }
        ]
      },
      "created_by": {
        "data": {
          "id": "00000000-0000-0000-0000-000000000000",
          "type": "user"
        }
      },
      "modified_by": {
        "data": {
          "id": "00000000-0000-0000-0000-000000000000",
          "type": "user"
        }
      }
    },
    "type": "change_request"
  },
  "included": [
    {
      "attributes": {
        "email": "john.doe@example.com",
        "handle": "john.doe@example.com",
        "name": "John Doe"
      },
      "id": "00000000-0000-0000-0000-000000000000",
      "type": "user"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Forbidden
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \## default
# 
 \# Curl command curl -X POST "https://api.datadoghq.com/api/v2/change-management/change-request" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "change_request_linked_incident_uuid": "00000000-0000-0000-0000-000000000000",
      "change_request_maintenance_window_query": "",
      "change_request_plan": "1. Deploy to staging 2. Run tests 3. Deploy to production",
      "change_request_risk": "LOW",
      "change_request_type": "NORMAL",
      "description": "Deploying new payment service v2.1",
      "end_date": "2024-01-02T15:00:00Z",
      "project_id": "d4bbe1af-f36e-42f1-87c1-493ca35c320e",
      "requested_teams": [
        "team-handle-1"
      ],
      "start_date": "2024-01-01T03:00:00Z",
      "title": "Deploy new payment service"
    },
    "type": "change_request"
  }
}
EOF 
                
##### 

```python
"""
Create a change request returns "Created" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.change_management_api import ChangeManagementApi
from datadog_api_client.v2.model.change_request_change_type import ChangeRequestChangeType
from datadog_api_client.v2.model.change_request_create_attributes import ChangeRequestCreateAttributes
from datadog_api_client.v2.model.change_request_create_data import ChangeRequestCreateData
from datadog_api_client.v2.model.change_request_create_request import ChangeRequestCreateRequest
from datadog_api_client.v2.model.change_request_resource_type import ChangeRequestResourceType
from datadog_api_client.v2.model.change_request_risk_level import ChangeRequestRiskLevel
from datetime import datetime
from dateutil.tz import tzutc

body = ChangeRequestCreateRequest(
    data=ChangeRequestCreateData(
        attributes=ChangeRequestCreateAttributes(
            change_request_linked_incident_uuid="00000000-0000-0000-0000-000000000000",
            change_request_maintenance_window_query="",
            change_request_plan="1. Deploy to staging 2. Run tests 3. Deploy to production",
            change_request_risk=ChangeRequestRiskLevel.LOW,
            change_request_type=ChangeRequestChangeType.NORMAL,
            description="Deploying new payment service v2.1",
            end_date=datetime(2024, 1, 2, 15, 0, tzinfo=tzutc()),
            project_id="d4bbe1af-f36e-42f1-87c1-493ca35c320e",
            requested_teams=[
                "team-handle-1",
            ],
            start_date=datetime(2024, 1, 1, 3, 0, tzinfo=tzutc()),
            title="Deploy new payment service",
        ),
        type=ChangeRequestResourceType.CHANGE_REQUEST,
    ),
)

configuration = Configuration()
configuration.unstable_operations["create_change_request"] = True
with ApiClient(configuration) as api_client:
    api_instance = ChangeManagementApi(api_client)
    response = api_instance.create_change_request(body=body)

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
##### 

```ruby
# Create a change request returns "Created" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.unstable_operations["v2.create_change_request".to_sym] = true
end
api_instance = DatadogAPIClient::V2::ChangeManagementAPI.new

body = DatadogAPIClient::V2::ChangeRequestCreateRequest.new({
  data: DatadogAPIClient::V2::ChangeRequestCreateData.new({
    attributes: DatadogAPIClient::V2::ChangeRequestCreateAttributes.new({
      change_request_linked_incident_uuid: "00000000-0000-0000-0000-000000000000",
      change_request_maintenance_window_query: "",
      change_request_plan: "1. Deploy to staging 2. Run tests 3. Deploy to production",
      change_request_risk: DatadogAPIClient::V2::ChangeRequestRiskLevel::LOW,
      change_request_type: DatadogAPIClient::V2::ChangeRequestChangeType::NORMAL,
      description: "Deploying new payment service v2.1",
      end_date: "2024-01-02T15:00:00Z",
      project_id: "d4bbe1af-f36e-42f1-87c1-493ca35c320e",
      requested_teams: [
        "team-handle-1",
      ],
      start_date: "2024-01-01T03:00:00Z",
      title: "Deploy new payment service",
    }),
    type: DatadogAPIClient::V2::ChangeRequestResourceType::CHANGE_REQUEST,
  }),
})
p api_instance.create_change_request(body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
##### 

```go
// Create a change request returns "Created" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"
	"time"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	body := datadogV2.ChangeRequestCreateRequest{
		Data: datadogV2.ChangeRequestCreateData{
			Attributes: datadogV2.ChangeRequestCreateAttributes{
				ChangeRequestLinkedIncidentUuid:     datadog.PtrString("00000000-0000-0000-0000-000000000000"),
				ChangeRequestMaintenanceWindowQuery: datadog.PtrString(""),
				ChangeRequestPlan:                   datadog.PtrString("1. Deploy to staging 2. Run tests 3. Deploy to production"),
				ChangeRequestRisk:                   datadogV2.CHANGEREQUESTRISKLEVEL_LOW.Ptr(),
				ChangeRequestType:                   datadogV2.CHANGEREQUESTCHANGETYPE_NORMAL.Ptr(),
				Description:                         datadog.PtrString("Deploying new payment service v2.1"),
				EndDate:                             datadog.PtrTime(time.Date(2024, 1, 2, 15, 0, 0, 0, time.UTC)),
				ProjectId:                           datadog.PtrString("d4bbe1af-f36e-42f1-87c1-493ca35c320e"),
				RequestedTeams: []string{
					"team-handle-1",
				},
				StartDate: datadog.PtrTime(time.Date(2024, 1, 1, 3, 0, 0, 0, time.UTC)),
				Title:     "Deploy new payment service",
			},
			Type: datadogV2.CHANGEREQUESTRESOURCETYPE_CHANGE_REQUEST,
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	configuration.SetUnstableOperationEnabled("v2.CreateChangeRequest", true)
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewChangeManagementApi(apiClient)
	resp, r, err := api.CreateChangeRequest(ctx, body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `ChangeManagementApi.CreateChangeRequest`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `ChangeManagementApi.CreateChangeRequest`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
##### 

```java
// Create a change request returns "Created" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.ChangeManagementApi;
import com.datadog.api.client.v2.model.ChangeRequestChangeType;
import com.datadog.api.client.v2.model.ChangeRequestCreateAttributes;
import com.datadog.api.client.v2.model.ChangeRequestCreateData;
import com.datadog.api.client.v2.model.ChangeRequestCreateRequest;
import com.datadog.api.client.v2.model.ChangeRequestResourceType;
import com.datadog.api.client.v2.model.ChangeRequestResponse;
import com.datadog.api.client.v2.model.ChangeRequestRiskLevel;
import java.time.OffsetDateTime;
import java.util.Collections;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setUnstableOperationEnabled("v2.createChangeRequest", true);
    ChangeManagementApi apiInstance = new ChangeManagementApi(defaultClient);

    ChangeRequestCreateRequest body =
        new ChangeRequestCreateRequest()
            .data(
                new ChangeRequestCreateData()
                    .attributes(
                        new ChangeRequestCreateAttributes()
                            .changeRequestLinkedIncidentUuid("00000000-0000-0000-0000-000000000000")
                            .changeRequestMaintenanceWindowQuery("")
                            .changeRequestPlan(
                                "1. Deploy to staging 2. Run tests 3. Deploy to production")
                            .changeRequestRisk(ChangeRequestRiskLevel.LOW)
                            .changeRequestType(ChangeRequestChangeType.NORMAL)
                            .description("Deploying new payment service v2.1")
                            .endDate(OffsetDateTime.parse("2024-01-02T15:00:00Z"))
                            .projectId("d4bbe1af-f36e-42f1-87c1-493ca35c320e")
                            .requestedTeams(Collections.singletonList("team-handle-1"))
                            .startDate(OffsetDateTime.parse("2024-01-01T03:00:00Z"))
                            .title("Deploy new payment service"))
                    .type(ChangeRequestResourceType.CHANGE_REQUEST));

    try {
      ChangeRequestResponse result = apiInstance.createChangeRequest(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling ChangeManagementApi#createChangeRequest");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
##### 

```rust
// Create a change request returns "Created" response
use chrono::{DateTime, Utc};
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_change_management::ChangeManagementAPI;
use datadog_api_client::datadogV2::model::ChangeRequestChangeType;
use datadog_api_client::datadogV2::model::ChangeRequestCreateAttributes;
use datadog_api_client::datadogV2::model::ChangeRequestCreateData;
use datadog_api_client::datadogV2::model::ChangeRequestCreateRequest;
use datadog_api_client::datadogV2::model::ChangeRequestResourceType;
use datadog_api_client::datadogV2::model::ChangeRequestRiskLevel;

#[tokio::main]
async fn main() {
    let body = ChangeRequestCreateRequest::new(ChangeRequestCreateData::new(
        ChangeRequestCreateAttributes::new("Deploy new payment service".to_string())
            .change_request_linked_incident_uuid("00000000-0000-0000-0000-000000000000".to_string())
            .change_request_maintenance_window_query("".to_string())
            .change_request_plan(
                "1. Deploy to staging 2. Run tests 3. Deploy to production".to_string(),
            )
            .change_request_risk(ChangeRequestRiskLevel::LOW)
            .change_request_type(ChangeRequestChangeType::NORMAL)
            .description("Deploying new payment service v2.1".to_string())
            .end_date(
                DateTime::parse_from_rfc3339("2024-01-02T15:00:00+00:00")
                    .expect("Failed to parse datetime")
                    .with_timezone(&Utc),
            )
            .project_id("d4bbe1af-f36e-42f1-87c1-493ca35c320e".to_string())
            .requested_teams(vec!["team-handle-1".to_string()])
            .start_date(
                DateTime::parse_from_rfc3339("2024-01-01T03:00:00+00:00")
                    .expect("Failed to parse datetime")
                    .with_timezone(&Utc),
            ),
        ChangeRequestResourceType::CHANGE_REQUEST,
    ));
    let mut configuration = datadog::Configuration::new();
    configuration.set_unstable_operation_enabled("v2.CreateChangeRequest", true);
    let api = ChangeManagementAPI::with_config(configuration);
    let resp = api.create_change_request(body).await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
##### 

```typescript
/**
 * Create a change request returns "Created" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
configuration.unstableOperations["v2.createChangeRequest"] = true;
const apiInstance = new v2.ChangeManagementApi(configuration);

const params: v2.ChangeManagementApiCreateChangeRequestRequest = {
  body: {
    data: {
      attributes: {
        changeRequestLinkedIncidentUuid: "00000000-0000-0000-0000-000000000000",
        changeRequestMaintenanceWindowQuery: "",
        changeRequestPlan:
          "1. Deploy to staging 2. Run tests 3. Deploy to production",
        changeRequestRisk: "LOW",
        changeRequestType: "NORMAL",
        description: "Deploying new payment service v2.1",
        endDate: new Date(2024, 1, 2, 15, 0, 0, 0),
        projectId: "d4bbe1af-f36e-42f1-87c1-493ca35c320e",
        requestedTeams: ["team-handle-1"],
        startDate: new Date(2024, 1, 1, 3, 0, 0, 0),
        title: "Deploy new payment service",
      },
      type: "change_request",
    },
  },
};

apiInstance
  .createChangeRequest(params)
  .then((data: v2.ChangeRequestResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"
{% /tab %}
